=== modified file '.bzrignore'
--- .bzrignore	2009-04-01 14:40:05 +0000
+++ .bzrignore	2009-02-10 01:57:06 +0000
@@ -6,4 +6,3 @@
 build
 *.log
 _trial_temp
-loggerhead-memprofile

=== modified file 'NEWS'
--- NEWS	2009-04-16 21:49:48 +0000
+++ NEWS	2009-03-04 21:02:14 +0000
@@ -5,7 +5,7 @@
 ---------------
 
     - Loggerhead now serves bzr branches over HTTP and exposes the URL
-      to branch them. Addresses bug #240577. (Jonathan Lange)
+      to branch them. (Jonathan Lange)
 
     - Leading blank lines in commit messages no longer result in an
       empty summary. (Colin Watson)
@@ -43,12 +43,6 @@
     - Changelog messages are now displayed with newlines preserved.
       (Peter Bui)
 
-    - serve-branches now has an option, --use-cdn, to load YUI from
-      Yahoo!'s CDN. (Matt Nordhoff)
-
-    - Fix bug #361238 (serve-branches was calling config.get_option()
-      incorrectly and failing). (Matt Nordhoff)
-
 1.10 [22Dec2008]
 ---------------
 

=== modified file 'loggerhead/apps/branch.py'
--- loggerhead/apps/branch.py	2009-04-07 18:29:10 +0000
+++ loggerhead/apps/branch.py	2009-03-17 00:02:21 +0000
@@ -31,7 +31,7 @@
 
     def __init__(self, branch, friendly_name=None, config={},
                  graph_cache=None, branch_link=None, is_root=False,
-                 served_url=_DEFAULT, use_cdn=False):
+                 served_url=_DEFAULT):
         self.branch = branch
         self._config = config
         self.friendly_name = friendly_name
@@ -42,7 +42,6 @@
         self.graph_cache = graph_cache
         self.is_root = is_root
         self.served_url = served_url
-        self.use_cdn = use_cdn
 
     def get_history(self):
         _history = History(self.branch, self.graph_cache)
@@ -80,13 +79,6 @@
     def static_url(self, path):
         return self._static_url_base + path
 
-    def yui_url(self, path):
-        if self.use_cdn:
-            base = 'http://yui.yahooapis.com/3.0.0pr2/build/'
-        else:
-            base = self.static_url('/static/javascript/yui/build/')
-        return base + path
-
     controllers_dict = {
         '+filediff': FileDiffUI,
         '+revlog': RevLogUI,

=== modified file 'loggerhead/apps/filesystem.py'
--- loggerhead/apps/filesystem.py	2009-04-16 23:47:26 +0000
+++ loggerhead/apps/filesystem.py	2009-02-19 18:04:11 +0000
@@ -1,6 +1,7 @@
 """Serve branches at urls that mimic the file system layout."""
 
 import os
+import tempfile
 
 from bzrlib import branch, errors, lru_cache
 
@@ -10,9 +11,10 @@
 
 from loggerhead.apps.branch import BranchWSGIApp
 from loggerhead.apps import favicon_app, static_app
-from loggerhead.config import LoggerheadConfig
 from loggerhead.controllers.directory_ui import DirectoryUI
 
+sql_dir = tempfile.mkdtemp(prefix='loggerhead-cache-')
+
 
 class BranchesFromFileSystemServer(object):
 
@@ -20,7 +22,6 @@
         self.path = path
         self.root = root
         self.name = name
-        self._config = LoggerheadConfig()
 
     def app_for_branch(self, branch):
         if not self.name:
@@ -30,10 +31,8 @@
             name = self.name
             is_root = False
         branch_app = BranchWSGIApp(
-            branch, name,
-            {'cachepath': self._config.SQL_DIR},
-            self.root.graph_cache, is_root=is_root,
-            use_cdn=self._config.get_option('use_cdn'))
+            branch, name, {'cachepath': sql_dir}, self.root.graph_cache,
+            is_root=is_root)
         return branch_app.app
 
     def app_for_non_branch(self, environ):
@@ -99,7 +98,7 @@
 
     def __call__(self, environ, start_response):
         environ['loggerhead.static.url'] = environ['SCRIPT_NAME']
-        path_info = environ['PATH_INFO']
+        path_info= environ['PATH_INFO']
         if path_info.startswith('/static/'):
             segment = path_info_pop(environ)
             assert segment == 'static'

=== removed file 'loggerhead/config.py'
--- loggerhead/config.py	2009-04-07 19:00:26 +0000
+++ loggerhead/config.py	1970-01-01 00:00:00 +0000
@@ -1,69 +0,0 @@
-'''Configuration tools for Loggerhead.'''
-from optparse import OptionParser
-import sys
-import tempfile
-
-
-def command_line_parser():
-    parser = OptionParser("%prog [options] <path>")
-    parser.set_defaults(
-        user_dirs=False,
-        show_version=False,
-        log_folder=None,
-        use_cdn=False,
-        )
-    parser.add_option("--user-dirs", action="store_true", dest="user_dirs",
-                      help="Serve user directories as ~user.")
-    parser.add_option("--trunk-dir", metavar="DIR",
-                      help="The directory that contains the trunk branches.")
-    parser.add_option("--port", dest="user_port",
-                      help=("Port Loggerhead should listen on "
-                            "(defaults to 8080)."))
-    parser.add_option("--host", dest="user_host",
-                      help="Host Loggerhead should listen on.")
-    parser.add_option('--memory-profile', action='store_true',
-                      dest='memory_profile',
-                      help='Profile the memory usage using heapy.')
-    parser.add_option("--prefix", dest="user_prefix",
-                      help="Specify host prefix.")
-    parser.add_option("--profile", action="store_true", dest="profile",
-                      help="Generate callgrind profile data to "
-                        "%d-stats.callgrind on each request.")
-    parser.add_option("--reload", action="store_true", dest="reload",
-                      help="Restarts the application when changing python"
-                           " files. Only used for development purposes.")
-    parser.add_option('--log-folder', dest="log_folder",
-                      type=str, help="The directory to place log files in.")
-    parser.add_option("--version", action="store_true", dest="show_version",
-                      help="Print the software version and exit")
-    parser.add_option('--use-cdn', action='store_true',
-                      help="Serve YUI from Yahoo!'s CDN")
-    return parser
-
-
-class LoggerheadConfig(object):
-    '''A configuration object.'''
-
-    def __init__(self):
-        self._parser = command_line_parser()
-        self._options, self._args = self._parser.parse_args(sys.argv[1:])
-
-        self.SQL_DIR = tempfile.mkdtemp(prefix='loggerhead-cache-')
-
-    def get_option(self, option):
-        '''Get an option from the options dict.'''
-        return getattr(self._options, option)
-
-    def get_arg(self, index):
-        '''Get an arg from the arg list.'''
-        return self._args[index]
-
-    def print_help(self):
-        '''Wrapper around OptionParser.print_help.'''
-        return self._parser.print_help()
-
-    @property
-    def arg_count(self):
-        '''Return the number of args from the option parser.'''
-        return len(self._args)
-

=== modified file 'loggerhead/history.py'
--- loggerhead/history.py	2009-04-18 06:16:28 +0000
+++ loggerhead/history.py	2009-03-19 20:04:24 +0000
@@ -34,23 +34,30 @@
 import re
 import textwrap
 import threading
+import time
+import urllib
+from StringIO import StringIO
 
 from loggerhead import search
 from loggerhead import util
 from loggerhead.wholehistory import compute_whole_history_data
 
+import bzrlib
 import bzrlib.branch
 import bzrlib.delta
+import bzrlib.diff
 import bzrlib.errors
 import bzrlib.progress
 import bzrlib.revision
+import bzrlib.textfile
+import bzrlib.tsort
 import bzrlib.ui
 
 # bzrlib's UIFactory is not thread-safe
 uihack = threading.local()
 
 
-class ThreadSafeUIFactory(bzrlib.ui.SilentUIFactory):
+class ThreadSafeUIFactory (bzrlib.ui.SilentUIFactory):
 
     def nested_progress_bar(self):
         if getattr(uihack, '_progress_bar_stack', None) is None:
@@ -124,7 +131,6 @@
         return len(self.revid_list)
 
 class FileChangeReporter(object):
-
     def __init__(self, old_inv, new_inv):
         self.added = []
         self.modified = []
@@ -171,7 +177,7 @@
                 file_id=file_id))
 
 
-class History(object):
+class History (object):
     """Decorate a branch to provide information for rendering.
 
     History objects are expected to be short lived -- when serving a request
@@ -635,8 +641,8 @@
             text_changes: list((filename, file_id)),
         """
         repo = self._branch.repository
-        if (bzrlib.revision.is_null(old_revid) or
-            bzrlib.revision.is_null(new_revid)):
+        if bzrlib.revision.is_null(old_revid) or \
+               bzrlib.revision.is_null(new_revid):
             old_tree, new_tree = map(
                 repo.revision_tree, [old_revid, new_revid])
         else:

=== modified file 'loggerhead/middleware/profile.py'
--- loggerhead/middleware/profile.py	2009-04-18 06:30:47 +0000
+++ loggerhead/middleware/profile.py	2009-03-30 22:05:16 +0000
@@ -1,11 +1,11 @@
 '''Profiling middleware for paste.'''
-
+import cgi
 import logging
 import sys
 import threading
 
 from bzrlib.lsprof import profile
-
+from guppy import hpy
 
 class LSProfMiddleware(object):
     '''Paste middleware for profiling with lsprof.'''

=== modified file 'loggerhead/search.py'
--- loggerhead/search.py	2009-04-17 03:38:04 +0000
+++ loggerhead/search.py	2008-11-05 00:50:06 +0000
@@ -17,18 +17,13 @@
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 #
-
-_mod_index = None
-def import_search():
-    global errors, _mod_index, FileTextHit, RevisionHit
-    if _mod_index is not None:
-        return
-    try:
-        from bzrlib.plugins.search import errors
-        from bzrlib.plugins.search import index as _mod_index
-        from bzrlib.plugins.search.index import FileTextHit, RevisionHit
-    except ImportError:
-        _mod_index = None
+import sets
+try:
+    from bzrlib.plugins.search import errors
+    from bzrlib.plugins.search import index as _mod_index
+    from bzrlib.plugins.search.index import FileTextHit, RevisionHit
+except ImportError:
+    _mod_index = None
 
 
 def search_revisions(branch, query_list, suggest=False):
@@ -41,7 +36,6 @@
     param suggest: Optional flag to request suggestions instead of results
     return: A list for results, either revision ids or terms
     """
-    import_search()
     if _mod_index is None:
         return None # None indicates could-not-search
     try:
@@ -65,6 +59,6 @@
                     revid_list.append(result.text_key[1])
                 elif isinstance(result, RevisionHit):
                     revid_list.append(result.revision_key[0])
-            return list(set(revid_list))
+            return list(sets.Set(revid_list))
     finally:
         index._branch.unlock()

=== modified file 'loggerhead/static/javascript/changelog.js'
--- loggerhead/static/javascript/changelog.js	2009-03-31 21:11:38 +0000
+++ loggerhead/static/javascript/changelog.js	2009-03-16 02:58:10 +0000
@@ -60,6 +60,7 @@
             open_node: item.query('.long_description'),
             close_node: item.query('.short_description'),
             source: global_path + '+revlog/' + revid,
+            source_target: item.query('.source_target'),
             loading: item.query('.loading'),
             is_open: false
           });

=== modified file 'loggerhead/static/javascript/custom.js'
--- loggerhead/static/javascript/custom.js	2009-04-01 15:28:21 +0000
+++ loggerhead/static/javascript/custom.js	2009-03-17 04:26:28 +0000
@@ -1,4 +1,6 @@
-Y = YUI().use("node", "io-base", "anim");
+Y = YUI().use("node", "io-base", "io-queue", "anim");
+
+Y.io.queue.size(2);
 
 var global_timeout_id = null;
 var global_search_request = null;
@@ -78,15 +80,13 @@
 function Collapsable(config)
 {
   this.is_open = config.is_open;
+  this.source_target = config.source_target;
   this.open_node = config.open_node;
   this.close_node = config.close_node;
   this.expand_icon = config.expand_icon;
   this.source = config.source;
   this.loading = config.loading;
   this.node_process = config.node_process;
-  this.container = null;
-  this.anim = null;
-  this._loading = false;
 }
 
 function get_height(node) {
@@ -100,116 +100,23 @@
   return height;
 }
 
-Collapsable.prototype._animate = function (callback)
-{
-  if (this.anim) this.anim.stop();
-
-  this.anim = new Y.Anim(
-    {
-      node: this.container,
-      from: {
-        marginBottom: this.container.getStyle('marginBottom')
-      },
-      to: {
-        marginBottom: 0
-      },
-      duration: 0.2
-    });
-
-  this.anim.run();
-  this.anim.on('end', this.animComplete, this, callback);
-}
-
 Collapsable.prototype._load_finished = function(tid, res, args)
 {
-  var l = res.responseText.split('\n');
-  l.splice(0, 1);
-  var newNode = Y.Node.create(l.join(''));
+  var newNode = Y.Node.create(res.responseText.split('\n').splice(1).join(''));
   if (this.node_process)
     this.node_process(newNode);
+  this.source_target.ancestor().replaceChild(newNode, this.source_target);
+  this.source_target = null;
   this.source = null;
-  newNode.setStyle('display', 'none');
-  this.loading.ancestor().insertBefore(newNode, this.loading);
-  var delta = this.loading.get('region').height - get_height(newNode);
-  newNode.setStyle('display', 'block');
-  this.container.setStyle('marginBottom', parseFloat(this.container.getStyle('marginBottom')) + delta);
-  this.loading.ancestor().removeChild(this.loading);
-  this._animate(args[0]);
+  this.loading.setStyle('display', 'none');
+  this.open(args[0]);
 };
 
-Collapsable.prototype._ensure_container = function(callback)
-{
-  if (this.container == null) {
-    this.container = Y.Node.create('<div></div>');
-    if (this.closed_node) {
-      this.closed_node.ancestor().replaceChild(
-        this.container, this.closed_node);
-      this.container.appendChild(this.closed_node);
-      if (this.open_node) {
-        this.container.appendChild(this.open_node);
-      }
-    }
-    else {
-      this.open_node.ancestor().replaceChild(
-        this.container, this.open_node);
-      this.container.appendChild(this.open_node);
-    }
-    var outer = Y.Node.create('<div style="overflow:hidden;"></div>');
-    this.container.ancestor().replaceChild(outer, this.container);
-    outer.appendChild(this.container);
-  }
-}
-
-/* What happens when you click open.
- *
- * 1. The arrow flips to the expanded position.
- *
- * 2. If necessary, the div which will be running the animation is
- * created and the open/closed content stuffed into it (and has height
- * set to the height of the closed content).
- *
- * 3. The open content is shown and the closed content is closed.
- *
- * 4. The animation to expose all of the open content is started.
- *
- * 5. If we have to do ajax to load content, start the request.
- *
- * 6. When the request completes, parse the content into a node, run
- * the node_process callback over it and replace the spinner (assumed
- * to be appropriately contained in the open node) with the new node.
- *
- * 7. If the animation showing the open content has not completed,
- * stop it.
- *
- * 8. Start a new animation to show the rest of the new content.
- */
-
 Collapsable.prototype.open = function(callback)
 {
-  this.expand_icon.set('src', expanded_icon_path);
-
-  this._ensure_container();
-
-  var open_height = get_height(this.open_node);
-
-  var close_height;
-  if (this.close_node) {
-    close_height = this.close_node.get('region').height;
-  }
-  else {
-    close_height = 0;
-  }
-
-  this.container.setStyle('marginBottom', close_height - open_height);
-  if (this.close_node) {
-    this.close_node.setStyle('display', 'none');
-  }
-  this.open_node.setStyle('display', 'block');
-
-  this._animate(callback);
-
   if (this.source) {
-    Y.io(
+    this.loading.setStyle('display', 'block');
+    Y.io.queue(
       this.source,
       {
         on: {complete: this._load_finished},
@@ -219,19 +126,49 @@
     return;
   }
 
+  var open_height = get_height(this.open_node);
+
+  var close_height;
+  if (this.close_node) {
+    close_height = this.close_node.get('region').height;
+  }
+  else {
+    close_height = 0;
+  }
+
+  var container = this.open_node.ancestor('.container');
+
+  var anim = new Y.Anim(
+    {
+      node: container,
+      from: {
+        marginBottom: close_height - open_height
+      },
+      to: {
+        marginBottom: 0
+      },
+      duration: 0.2
+    });
+
+  anim.on('end', this.openComplete, this, callback);
+  container.setStyle('marginBottom', close_height - open_height);
+  if (this.close_node) {
+    this.close_node.setStyle('display', 'none');
+  }
+  this.open_node.setStyle('display', 'block');
+  this.expand_icon.set('src', this.expand_icon.get('alt'));
+  anim.run();
 };
 
-Collapsable.prototype.animComplete = function(evt, callback)
+Collapsable.prototype.openComplete = function(evt, callback)
 {
-  this.anim = null;
-  if (this._loading) return;
   if (callback) callback();
   this.is_open = true;
 };
 
 Collapsable.prototype.close = function()
 {
-  this._ensure_container();
+  var container = this.open_node.ancestor('.container');
 
   var open_height = this.open_node.get('region').height;
 
@@ -245,7 +182,7 @@
 
   var anim = new Y.Anim(
     {
-      node: this.container,
+      node: container,
       from: {
         marginBottom: 0
       },
@@ -263,8 +200,8 @@
   if (this.close_node) {
     this.close_node.setStyle('display', 'block');
   }
-  this.container.setStyle('marginBottom', 0);
-  this.expand_icon.set('src', collapsed_icon_path);
+  this.open_node.ancestor('.container').setStyle('marginBottom', 0);
+  this.expand_icon.set('src', this.expand_icon.get('title'));
   this.is_open = false;
 };
 

=== modified file 'loggerhead/static/javascript/diff.js'
--- loggerhead/static/javascript/diff.js	2009-03-31 21:11:38 +0000
+++ loggerhead/static/javascript/diff.js	2009-03-18 04:08:41 +0000
@@ -192,6 +192,7 @@
             open_node: item.query('.diffinfo'),
             close_node: null,
             source: source_url,
+            source_target: item.query('.source_target'),
             is_open: specific_path != null,
             loading: item.query('.loading'),
             node_process: node_process

=== modified file 'loggerhead/templatefunctions.py'
--- loggerhead/templatefunctions.py	2009-04-17 03:38:04 +0000
+++ loggerhead/templatefunctions.py	2009-03-19 00:18:46 +0000
@@ -13,7 +13,6 @@
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 #
-
 import cgi
 import os
 from loggerhead.zptsupport import zpt

=== modified file 'loggerhead/templates/changelog.pt'
--- loggerhead/templates/changelog.pt	2009-03-31 21:15:48 +0000
+++ loggerhead/templates/changelog.pt	2009-03-16 23:21:29 +0000
@@ -86,26 +86,37 @@
             </td>
             <td class="expcell show_if_js">
               <div class="expand_revisioninfo">
+                <!-- So, this is interesting. I'm using "alt" to have the correct URL for the image of the expanded icon
+                     and "title" tag for the contracted URL of the image. This is a bit of a hack, but it's better than
+                     other approaches I tried  :)  -->
                 <a href="#">
-                  <img tal:attributes="src python:branch.static_url('/static/images/treeCollapsed.png')"
+                  <img tal:attributes="src python:branch.static_url('/static/images/treeCollapsed.png');
+                                       alt python:branch.static_url('/static/images/treeExpanded.png');
+                                       title python:branch.static_url('/static/images/treeCollapsed.png')"
                        class="expand_icon" />
                 </a>
               </div>
             </td>
             <td class="summcell">
-              <div class="short_description">
-                <a tal:attributes="title python:'Show revision '+entry.revno;
-                                   href  python:url(['/revision', entry.revno], clear=1);
-                                   class string:link"
-                   tal:content="entry/short_comment"></a>
-              </div>
-              <div class="long_description" style="display: none">
-                <a tal:attributes="title python:'Show revision '+entry.revno;
-                                   href  python:url(['/revision', entry.revno], clear=1);
-                                   class string:link"
-                   tal:content="structure python:util.fixed_width(entry.comment)"></a>
-                <div class="loading">
-                  <img tal:attributes="src python:branch.static_url('/static/images/spinner.gif')" />
+              <div style="overflow: hidden">
+                <div class="container">
+                  <div class="short_description">
+                    <a tal:attributes="title python:'Show revision '+entry.revno;
+                                       href  python:url(['/revision', entry.revno], clear=1);
+                                       class string:link"
+                       tal:content="entry/short_comment"></a>
+                    <div class="loading" style="display:none;">
+                      <img tal:attributes="src python:branch.static_url('/static/images/spinner.gif')" />
+                    </div>
+                  </div>
+                  <div class="long_description" style="display: none">
+                    <a tal:attributes="title python:'Show revision '+entry.revno;
+                                       href  python:url(['/revision', entry.revno], clear=1);
+                                       class string:link"
+                       tal:content="structure python:util.fixed_width(entry.comment)"></a>
+                    <div class="source_target">
+                    </div>
+                  </div>
                 </div>
               </div>
             </td>

=== modified file 'loggerhead/templates/filediff.pt'
--- loggerhead/templates/filediff.pt	2009-04-01 15:28:21 +0000
+++ loggerhead/templates/filediff.pt	2009-03-17 00:02:21 +0000
@@ -1,4 +1,4 @@
-<div>
+<div class="diffinfo">
   <div class="pseudotable unified"
        tal:repeat="chunk chunks">
 

=== modified file 'loggerhead/templates/macros.pt'
--- loggerhead/templates/macros.pt	2009-04-07 18:26:03 +0000
+++ loggerhead/templates/macros.pt	2009-03-16 03:22:02 +0000
@@ -13,27 +13,37 @@
     </tal:comment>
     <script type="text/javascript">
       var global_path = <tal:block content="python:'\''+branch.url('/')+'\''" />;
-      var collapsed_icon_path = <tal:block content="python:'\''+branch.static_url('/static/images/treeCollapsed.png')+'\''" />;
-      var expanded_icon_path = <tal:block content="python:'\''+branch.static_url('/static/images/treeExpanded.png')+'\''" />;
     </script>
     <script type="text/javascript"
-            tal:attributes="src python:branch.yui_url('yui/yui-min.js')"></script>
-    <script type="text/javascript"
-            tal:attributes="src python:branch.yui_url('oop/oop-min.js')"></script>
-    <script type="text/javascript"
-            tal:attributes="src python:branch.yui_url('event/event-min.js')"></script>
-    <script type="text/javascript"
-            tal:attributes="src python:branch.yui_url('attribute/attribute-min.js')"></script>
-    <script type="text/javascript"
-            tal:attributes="src python:branch.yui_url('base/base-min.js')"></script>
-    <script type="text/javascript"
-            tal:attributes="src python:branch.yui_url('dom/dom-min.js')"></script>
-    <script type="text/javascript"
-            tal:attributes="src python:branch.yui_url('node/node-min.js')"></script>
-    <script type="text/javascript"
-            tal:attributes="src python:branch.yui_url('anim/anim-min.js')"></script>
-    <script type="text/javascript"
-            tal:attributes="src python:branch.yui_url('io/io-base-min.js')"></script>
+            tal:attributes="src
+            python:branch.static_url('/static/javascript/yui/build/yui/yui-min.js')"></script>
+    <script type="text/javascript"
+            tal:attributes="src
+            python:branch.static_url('/static/javascript/yui/build/oop/oop-min.js')"></script>
+    <script type="text/javascript"
+            tal:attributes="src
+            python:branch.static_url('/static/javascript/yui/build/event/event-min.js')"></script>
+    <script type="text/javascript"
+            tal:attributes="src
+            python:branch.static_url('/static/javascript/yui/build/attribute/attribute-min.js')"></script>
+    <script type="text/javascript"
+            tal:attributes="src
+            python:branch.static_url('/static/javascript/yui/build/base/base-min.js')"></script>
+    <script type="text/javascript"
+            tal:attributes="src
+            python:branch.static_url('/static/javascript/yui/build/dom/dom-min.js')"></script>
+    <script type="text/javascript"
+            tal:attributes="src
+            python:branch.static_url('/static/javascript/yui/build/node/node-min.js')"></script>
+    <script type="text/javascript"
+            tal:attributes="src
+            python:branch.static_url('/static/javascript/yui/build/anim/anim-min.js')"></script>
+    <script type="text/javascript"
+            tal:attributes="src
+            python:branch.static_url('/static/javascript/yui/build/io/io-base-min.js')"></script>
+    <script type="text/javascript"
+            tal:attributes="src
+            python:branch.static_url('/static/javascript/yui/build/io/io-queue-min.js')"></script>
     <script type="text/javascript"
             tal:attributes="src python:branch.static_url('/static/javascript/custom.js')"></script>
     <metal:block metal:define-slot="header_extras" />

=== modified file 'loggerhead/templates/revision.pt'
--- loggerhead/templates/revision.pt	2009-03-31 21:15:48 +0000
+++ loggerhead/templates/revision.pt	2009-03-19 00:44:05 +0000
@@ -124,7 +124,9 @@
                                  id string:${specific_path};
                                  title string:View changes to ${specific_path} only"
                  class="the-link">
-                <img tal:attributes="src python:branch.static_url('/static/images/treeExpanded.png')"
+                <img tal:attributes="src python:branch.static_url('/static/images/treeExpanded.png');
+                                     title python:branch.static_url('/static/images/treeCollapsed.png');
+                                     alt python:branch.static_url('/static/images/treeExpanded.png')"
                      class="expand_diff"/>
                 <tal:b content="specific_path" />
               </a>
@@ -173,14 +175,22 @@
                                  id string:${item/filename};
                                  title string:View changes to ${item/filename} only"
                  class="the-link">
-                <img tal:attributes="src python:branch.static_url('/static/images/treeCollapsed.png')"
+                <img tal:attributes="src python:branch.static_url('/static/images/treeCollapsed.png');
+                                     title python:branch.static_url('/static/images/treeCollapsed.png');
+                                     alt python:branch.static_url('/static/images/treeExpanded.png')"
                      class="expand_diff" />
                 <tal:b content="item/filename" />
               </a>
             </div>
-            <div class="diffinfo"  style="display:none">
-              <div class="loading">
-                <img tal:attributes="src python:branch.static_url('/static/images/spinner.gif')" />
+            <div style="overflow: hidden">
+              <div class="container">
+                <div class="loading" style="display:none">
+                  <img tal:attributes="src python:branch.static_url('/static/images/spinner.gif')" />
+                </div>
+                <div class="diffinfo">
+                  <div class="source_target" >
+                  </div>
+                </div>
               </div>
             </div>
           </div>

=== modified file 'loggerhead/tests/test_corners.py'
--- loggerhead/tests/test_corners.py	2009-04-02 20:32:12 +0000
+++ loggerhead/tests/test_corners.py	2009-03-16 18:54:39 +0000
@@ -34,16 +34,6 @@
         res = app.get('/revision/'+newrevid)
         res.mustcontain('executable')
 
-    def test_revision_escapes_commit_message(self):
-        """XXX."""
-        self.createBranch()
-
-        msg = '<b>hi</b>'
-        self.addFileAndCommit('myfilename', msg)
-        app = self.setUpLoggerhead()
-        res = app.get('/revision/1')
-        self.assertFalse(msg in res.body)
-
     def test_empty_commit_message(self):
         """Check that an empty commit message does not break the rendering."""
         self.createBranch()

=== modified file 'loggerhead/util.py'
--- loggerhead/util.py	2009-04-18 06:30:47 +0000
+++ loggerhead/util.py	2009-03-19 20:31:49 +0000
@@ -250,7 +250,7 @@
         except UnicodeDecodeError:
             s = s.decode('iso-8859-15')
 
-    s = cgi.escape(s).expandtabs().replace(' ', NONBREAKING_SPACE)
+    s = s.expandtabs().replace(' ', NONBREAKING_SPACE)
 
     return HSC.clean(s).replace('\n', '<br/>')
 
@@ -537,7 +537,7 @@
     _reloader_environ_key = 'PYTHON_RELOADER_SHOULD_RUN'
 
     @classmethod
-    def _turn_sigterm_into_systemexit(cls):
+    def _turn_sigterm_into_systemexit(self):
         """
         Attempts to turn a SIGTERM exception into a SystemExit exception.
         """
@@ -551,16 +551,16 @@
         signal.signal(signal.SIGTERM, handle_term)
 
     @classmethod
-    def is_installed(cls):
+    def is_installed(self):
         return os.environ.get(self._reloader_environ_key)
 
     @classmethod
-    def install(cls):
+    def install(self):
         from paste import reloader
         reloader.install(int(1))
 
     @classmethod
-    def restart_with_reloader(cls):
+    def restart_with_reloader(self):
         """Based on restart_with_monitor from paste.script.serve."""
         print 'Starting subprocess with file monitor'
         while 1:

=== modified file 'serve-branches'
--- serve-branches	2009-04-16 21:49:48 +0000
+++ serve-branches	2009-03-30 22:11:06 +0000
@@ -19,6 +19,8 @@
 import os
 import sys
 
+from optparse import OptionParser
+
 from bzrlib.plugin import load_plugins
 
 from paste import httpserver
@@ -28,23 +30,57 @@
 from loggerhead import __version__
 from loggerhead.apps.filesystem import (
     BranchesFromFileSystemRoot, UserBranchesFromFileSystemRoot)
-from loggerhead.config import LoggerheadConfig
 from loggerhead.util import Reloader
 from loggerhead.apps.error import ErrorHandlerApp
 
 
+def command_line_parser():
+    parser = OptionParser("%prog [options] <path>")
+    parser.set_defaults(
+        user_dirs=False,
+        show_version=False,
+        log_folder=None,
+        )
+    parser.add_option("--user-dirs", action="store_true", dest="user_dirs",
+                      help="Serve user directories as ~user.")
+    parser.add_option("--trunk-dir", metavar="DIR",
+                      help="The directory that contains the trunk branches.")
+    parser.add_option("--port", dest="user_port",
+                      help=("Port Loggerhead should listen on "
+                            "(defaults to 8080)."))
+    parser.add_option("--host", dest="user_host",
+                      help="Host Loggerhead should listen on.")
+    parser.add_option('--memory-profile', action='store_true',
+                      dest='memory_profile',
+                      help='Profile the memory usage using heapy.')
+    parser.add_option("--prefix", dest="user_prefix",
+                      help="Specify host prefix.")
+    parser.add_option("--profile", action="store_true", dest="profile",
+                      help="Generate callgrind profile data to "
+                        "%d-stats.callgrind on each request.")
+    parser.add_option("--reload", action="store_true", dest="reload",
+                      help="Restarts the application when changing python"
+                           " files. Only used for development purposes.")
+    parser.add_option('--log-folder', dest="log_folder",
+                      type=str, help="The directory to place log files in.")
+    parser.add_option("--version", action="store_true", dest="show_version",
+                      help="Print the software version and exit")
+    return parser
+
+
 def main(args):
-    config = LoggerheadConfig()
+    parser = command_line_parser()
+    (options, args) = parser.parse_args(sys.argv[1:])
 
-    if config.get_option('show_version'):
+    if options.show_version:
         print "loggerhead %s" % __version__
         sys.exit(0)
 
-    if config.arg_count > 1:
-        config.print_help()
+    if len(args) > 1:
+        parser.print_help()
         sys.exit(1)
-    elif config.arg_count == 1:
-        path = config.get_arg(0)
+    elif len(args) == 1:
+        [path] = args
     else:
         path = '.'
 
@@ -52,22 +88,21 @@
         print "%s is not a directory" % path
         sys.exit(1)
 
-    if config.get_option('trunk_dir') and not config.get_option('user_dirs'):
+    if options.trunk_dir and not options.user_dirs:
         print "--trunk-dir is only valid with --user-dirs"
         sys.exit(1)
 
-    if config.get_option('reload'):
+    if options.reload:
         if Reloader.is_installed():
             Reloader.install()
         else:
             return Reloader.restart_with_reloader()
 
-    if config.get_option('user_dirs'):
-        if not config.get_option('trunk_dir'):
+    if options.user_dirs:
+        if not options.trunk_dir:
             print "You didn't specify a directory for the trunk directories."
             sys.exit(1)
-        app = UserBranchesFromFileSystemRoot(
-            path, config.get_option('trunk_dir'))
+        app = UserBranchesFromFileSystemRoot(path, options.trunk_dir)
     else:
         app = BranchesFromFileSystemRoot(path)
 
@@ -75,9 +110,8 @@
     logging.basicConfig()
     logging.getLogger('').setLevel(logging.DEBUG)
     logger = getattr(app, 'log', logging.getLogger('loggerhead'))
-    if config.get_option('log_folder'):
-        logfile_path = os.path.join(
-            config.get_option('log_folder'), 'serve-branches.log')
+    if options.log_folder:
+        logfile_path = os.path.join(options.log_folder, 'serve-branches.log')
     else:
         logfile_path = 'serve-branches.log'
     logfile = logging.FileHandler(logfile_path, 'a')
@@ -87,25 +121,24 @@
     logfile.setLevel(logging.DEBUG)
     logger.addHandler(logfile)
 
-    if config.get_option('memory_profile'):
-        memprofile = logging.getLogger('loggerhead-memprofile')
-        memprofile.setLevel(logging.DEBUG)
-        memprofile.addHandler(logging.FileHandler('loggerhead-memprofile'))
+    memprofile = logging.getLogger('loggerhead-memprofile')
+    memprofile.setLevel(logging.DEBUG)
+    memprofile.addHandler(logging.FileHandler('loggerhead-memprofile'))
 
     # setup_logging() #end
 
     app = TransLogger(app, logger=logger)
-    if config.get_option('profile'):
+    if options.profile:
         from loggerhead.middleware.profile import LSProfMiddleware
         app = LSProfMiddleware(app)
-    if config.get_option('memory_profile'):
+    if options.memory_profile:
         from loggerhead.middleware.profile import MemoryProfileMiddleware
         app = MemoryProfileMiddleware(app)
 
-    if not config.get_option('user_prefix'):
+    if not options.user_prefix:
         prefix = '/'
     else:
-        prefix = config.get_option('user_prefix')
+        prefix = options.user_prefix
         if not prefix.startswith('/'):
             prefix = '/' + prefix
 
@@ -130,15 +163,15 @@
     app = HTTPExceptionHandler(app)
     app = ErrorHandlerApp(app)
 
-    if not config.get_option('user_port'):
+    if not options.user_port:
         port = '8080'
     else:
-        port = config.get_option('user_port')
+        port = options.user_port
 
-    if not config.get_option('user_host'):
+    if not options.user_host:
         host = '0.0.0.0'
     else:
-        host = config.get_option('user_host')
+        host = options.user_host
 
     load_plugins()
 

=== modified file 'start-loggerhead'
--- start-loggerhead	2009-04-18 06:30:47 +0000
+++ start-loggerhead	2009-02-19 01:24:20 +0000
@@ -17,6 +17,7 @@
 
 
 import logging
+import logging.handlers
 from optparse import OptionParser
 import os
 import sys
@@ -31,7 +32,7 @@
 
 from loggerhead import daemon
 from loggerhead.apps.config import Root
-from loggerhead.trace import setup_logging
+from loggerhead.trace import make_handler, setup_logging
 from loggerhead.apps.error import ErrorHandlerApp
 
 

